//Project 3 2d visualizaton 
//Ramon Rovirosa
//Mat 259

import de.bezier.data.sql.*;
import java.util.Arrays;

MySQL msql;
String[] textArray = new String[1];
String DL = ","; //the DELIMITER

int[] transactionsPerHour = new int[1000];
foodMonth[][] foodArray = new foodMonth[2][61];
//foodMonth[] foodArray2 = new foodMonth[61];
foods[][][] foodMonthRank = new foods[2][61][6];
foods[] foods = new foods[6];

int [][] seattleMonths_Cuisines = new int[61][8];

////[0-2 if not selected][3-5 if selected]
//int [] dessertColor = {22,58,50,22,58,100};//58
//int [] spanishColor = {345,83,60,345,83,64};//83
//int [] chineseColor = {33,70,70,33,70,100};//70
//int [] frenchColor = {245,97,90,206,97,75};//97
//int [] vegetarianColor = {146,90,55,146,99,70};//90
//int [] italianColor  = {60,7,75,60,7,75};//

int [] dessertColor = {245,0,90,206,97,75};//58
int [] spanishColor = {245,20,90,206,97,75};//83
int [] chineseColor = {245,40,90,206,97,75};//70
int [] frenchColor =  {245,60,90,206,97,75};//97
int [] vegetarianColor = {245,80,90,206,97,75};//90
int [] italianColor  = {245,100,90,206,97,75};//


int _width = 980;
int _height = 640;

PFont fnt;

void setup() {
  size(_width, _height);
  smooth();
  colorMode(HSB,360,100,100);
  int saveData = 61;
  parseSeattleData();
  parseNYData();
  
  for(int i = 1; i<61;i++){
    foodArray[0][i] = new foodMonth(seattleMonths_Cuisines[i][0], seattleMonths_Cuisines[i][1], seattleMonths_Cuisines[i][2], seattleMonths_Cuisines[i][3], seattleMonths_Cuisines[i][4], seattleMonths_Cuisines[i][5], seattleMonths_Cuisines[i][6], seattleMonths_Cuisines[i][7] );
    foodArray[1][i] = new foodMonth(nyMonths_Cuisines[i][0], nyMonths_Cuisines[i][1], nyMonths_Cuisines[i][2], nyMonths_Cuisines[i][3], nyMonths_Cuisines[i][4], nyMonths_Cuisines[i][5], nyMonths_Cuisines[i][6], nyMonths_Cuisines[i][7] );
  }
  
  //each month order from greatest to smallest and asosciate with category.
  int temp[] = new int[6];
  for(int a=0;a<2;a++){
    for (int i=1;i<61;i++) {
      foodMonthRank[a][i][0] = new foods("Chinese", foodArray[a][i].getChinese());
      foodMonthRank[a][i][1]= new foods("Vegetarian", foodArray[a][i].getVegetarian() );
      foodMonthRank[a][i][2]= new foods("Spanish", foodArray[a][i].getSpanish());
      foodMonthRank[a][i][3]= new foods("Italian", foodArray[a][i].getItalian());
      foodMonthRank[a][i][4]= new foods("French", foodArray[a][i].getFrench() );
      foodMonthRank[a][i][5]= new foods("Dessert", foodArray[a][i].getDessert() );
  
      foods tempf = new foods("foo", 0);
      for (int j=0;j<6;j++) {
        for (int k=0;k<6;k++) {
          if (foodMonthRank[a][i][k].getCount() > foodMonthRank[a][i][j].getCount()) {
            tempf = foodMonthRank[a][i][k];
            foodMonthRank[a][i][k]=foodMonthRank[a][i][j];
            foodMonthRank[a][i][j]=tempf;
          }
        }
      }
    }
  }
  // println(foodMonthRank[1][1].getType());
  for(int a=0;a<2;a++){
    for (int i=1;i<61;i++) {
      foodMonthRank[a][i][0].setRank(1);
      foodMonthRank[a][i][1].setRank(2);
      foodMonthRank[a][i][2].setRank(3);
      foodMonthRank[a][i][3].setRank(4);
      foodMonthRank[a][i][4].setRank(5);
      foodMonthRank[a][i][5].setRank(6);
      
    }
  }


  fnt = createFont("Arial", 24, true);


  //println(foods[0].getCount()+foods[0].getType()+DL+foods[1].getCount()+foods[1].getType()+DL+foods[2].getCount()+foods[2].getType()+DL+foods[3].getCount()+foods[3].getType()+DL+foods[4].getCount()+foods[4].getType()+DL+foods[5].getCount()+foods[5].getType()+DL);

  //foodMonthRank[i][] = foods;
  //println(foodMonthRank[i][0].getCount()+"->"+foodMonthRank[i][0].getType()+"->"+foodMonthRank[i][1].getCount()+foodMonthRank[i][0].getType()+"->"+DL+foodMonthRank[i][2].getCount()+foodMonthRank[i][0].getType()+"->"+DL+foodMonthRank[i][3].getCount()+foodMonthRank[i][0].getType()+"->"+DL+foodMonthRank[i][4].getCount()+foodMonthRank[i][0].getType()+"->"+DL+foodMonthRank[i][5].getCount()+foodMonthRank[i][0].getType());
}
String typeAtXY;
void draw() {
  background(#000000);
  drawText();
  smooth();

  int position =0;  

  for(int a=0;a<2;a++){
    for (int i=1;i<61;i++) {
      for (int j=0;j<6;j++) {
        if(foodMonthRank[a][i][j].getType() == "Dessert"){
          position = 1;
          //fill(dessertColor[0],dessertColor[1],dessertColor[2]); 
        }
        if(foodMonthRank[a][i][j].getType() == "Spanish"){
          //fill(spanishColor[3],spanishColor[4],spanishColor[5]);
          position = 2;
        }
        if(foodMonthRank[a][i][j].getType() == "Chinese"){
          position = 3;
         //fill(chineseColor[0],chineseColor[1],chineseColor[2]); 
        }
        if(foodMonthRank[a][i][j].getType() == "French"){
          position = 4;
          //fill(frenchColor[0],frenchColor[1],frenchColor[2]);
        }
        if(foodMonthRank[a][i][j].getType() == "Vegetarian"){
          position = 5;
          //fill(vegetarianColor[0],vegetarianColor[1],vegetarianColor[2]);
        }
        if(foodMonthRank[a][i][j].getType() == "Italian"){
          position = 6;
         //fill(italianColor[0],italianColor[1],italianColor[2]); 
        }
        if(foodMonthRank[a][i][j].getRank() == 1){
          fill(dessertColor[0],dessertColor[1],dessertColor[2]);
          stroke(dessertColor[0],dessertColor[1],dessertColor[2]); 
        }
        if(foodMonthRank[a][i][j].getRank() == 2){
          fill(spanishColor[0],spanishColor[1],spanishColor[2]);
          stroke(spanishColor[0],spanishColor[1],spanishColor[2]);
        }
        if(foodMonthRank[a][i][j].getRank() == 3){
         fill(chineseColor[0],chineseColor[1],chineseColor[2]);
         stroke(chineseColor[0],chineseColor[1],chineseColor[2]);
        }
        if(foodMonthRank[a][i][j].getRank() == 4){
          fill(frenchColor[0],frenchColor[1],frenchColor[2]);
          stroke(frenchColor[0],frenchColor[1],frenchColor[2]);
        }
        if(foodMonthRank[a][i][j].getRank() == 5){
          fill(vegetarianColor[0],vegetarianColor[1],vegetarianColor[2]);
          stroke(vegetarianColor[0],vegetarianColor[1],vegetarianColor[2]);
        }
        if(foodMonthRank[a][i][j].getRank() == 6){
         stroke(italianColor[0],italianColor[1],italianColor[2]); 
         fill(italianColor[0],italianColor[1],italianColor[2]); 
        }
        smooth();
        //rect(5+.1*_width+(_width*.8/60)*(i-1), 5+.1*_height+(.8*_height/6)*j, .8*_width/60-5, .8*_height/6-5);
        if(a==0)
          ///text( foodMonthRank[a][i][j].getRank() ,5+.1*_width+(_width*.8/60)*(i-1), 5+.1*_height+(.8*_height/6)*(position-1)+35);
          rect(5+.1*_width+(_width*.8/60)*(i-1)-5, .1*_height+(.8*_height/6)*(position-1)+35,8,30);
        if(a==1)
          //text( foodMonthRank[a][i][j].getRank() ,5+.1*_width+(_width*.8/60)*(i-1), 5+.1*_height+(.8*_height/6)*(position-1) );
          rect(5+.1*_width+(_width*.8/60)*(i-1)-5, .1*_height+(.8*_height/6)*(position-1)+5,8,30);
        //println(mouseAtX(mouseX)); 
        //println(mouseAtX(mouseX)+DL+mouseAtY(mouseY)); 
        //strokeWeight(1);
      }
    }
  }
}

void parseSeattleData(){

  /*  
   // connecting to the SPL database
   msql = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
   if ( msql.connect() )
   { 
   String TheQuery="SELECT year(cout) as Years, month(cout) as Months, cout as Dates, itemtype,\nSUM(case When subj like \'%chinese%\' and subj like \'%food%\' Then 1 Else 0 End) as chinese,\nSUM(case When subj like \'%vegetarian%\' and subj like \'%food%\' Then 1 Else 0 End) as vegetarian,\nSUM(case When subj like \'%spanish%\' and subj like \'%food%\' Then 1 Else 0 End) as spanish,\nSUM(case When subj like \'%Italian%\' and subj like \'%food%\' Then 1 Else 0 End) as italian,\nSUM(case When subj like \'%french%\' and subj like \'%food%\' Then 1 Else 0 End) as french,\nSUM(case When subj like \'%dessert%\' and subj like \'%food%\' Then 1 Else 0 End) as dessert\n\nFROM inraw where year(cout)= (\'2007\') or year(cout)= (\'2008\') or year(cout)= (\'2009\') or year(cout)= (\'2010\') or year(cout)= (\'2011\') or year(cout)=(\'2012\') \nGROUP BY month(cout), year(cout);";
   println(TheQuery);
   msql.query( TheQuery);
   textArray[0] = TheQuery;
   while( msql.next() ){
   //always use msql.getString instead of getInt or getFloat, because we're just saving this to a text file.  
   //We'll cast them as floats or ints later when we import it into our actual visualization. 
   
   textArray = append(textArray, msql.getString(1) + DL + msql.getString(2)+ DL + msql.getString(3)+ DL + msql.getString(4)+ DL + msql.getString(5)+ DL + msql.getString(6)+ DL + msql.getString(7)+ DL + msql.getString(8)+ DL + msql.getString(9)+ DL + msql.getString(10)); //separate each column by the "^^" delimiter so that we can parse the file later on.  
   }     
   }
   
   else
   {
   println(" connection failed !");
   }
   ("done");
   saveStrings("savedData.txt", textArray);
   */

  String savedData[] = loadStrings("savedData.txt");
  println("QUERY: " + savedData[0]);
  for (int i=1; i < savedData.length; i++) {

    String temp[] = split(savedData[i], "\n");

    //println(temp[0]);

    String temp2[] = split(temp[0], ",");
    println( temp2[0] + DL + temp2[1] + DL + temp2[2] + DL + temp2[3] + DL + temp2[4] + DL+temp2[5] + DL + temp2[6] + DL + temp2[7] + DL + temp2[8]+ DL+ temp2[9] );
    //foodMonth(int chinese, int vegetarian, int spanish, int italian, int french, int dessert)
    seattleMonths_Cuisines[i][0] = Integer.parseInt(temp2[0]); 
    seattleMonths_Cuisines[i][1] = Integer.parseInt(temp2[1]);
    seattleMonths_Cuisines[i][2] = Integer.parseInt(temp2[4]);
    seattleMonths_Cuisines[i][3] = Integer.parseInt(temp2[5]);
    seattleMonths_Cuisines[i][4] = Integer.parseInt(temp2[6]);
    seattleMonths_Cuisines[i][5] = Integer.parseInt(temp2[7]);
    seattleMonths_Cuisines[i][6] = Integer.parseInt(temp2[8]);
    seattleMonths_Cuisines[i][7] = Integer.parseInt(temp2[9]);
    //foodArray[i] = new foodMonth(Integer.parseInt(temp2[0]), Integer.parseInt(temp2[1]), Integer.parseInt(temp2[4]), Integer.parseInt(temp2[5]), Integer.parseInt(temp2[6]), Integer.parseInt(temp2[7]), Integer.parseInt(temp2[8]), Integer.parseInt(temp2[9]) );
  }


}

int mouseAtX(int mouseX) {
  for (int i=1;i<=61;i++) {
    if (5+.1*_width+(_width*.8/60)*(i-1) > mouseX /*&& .1*_width+(_width*.8/60)*(i) < mouseX */)
      return i-1;
  }
  return 0;
}
int mouseAtY(int mouseY) {
  for (int i=1;i<=6;i++) {
    if (5+.1*_height+(.8*_height/6)*i > mouseY)
      return i;
  }
  return 0;
}



public class foodMonth {
  int chinese, vegetarian, spanish, italian, french, dessert;
  int _month, _year;

  foodMonth(int _year, int _month, int chinese, int vegetarian, int spanish, int italian, int french, int dessert) {
    this._year=_year;
    this._month = _month;

    this.chinese = chinese;
    this.vegetarian = vegetarian;
    this.spanish = spanish;
    this.italian = italian;
    this.french = french;
    this.dessert = dessert;
  }
  int getChinese() {
    return chinese;
  }
  void setChinese(int c) {
    chinese = c;
  }
  int getVegetarian() {
    return vegetarian;
  }
  void setVegetarian(int v) {
    vegetarian = v;
  }
  int getSpanish() {
    return spanish;
  }
  void setSpanish(int s) {
    spanish=s;
  }
  int getItalian() {
    return italian;
  }
  void setItalian(int i) {
    italian=i;
  }
  int getFrench() {
    return french;
  }
  void setFrench(int f) {
    french =f;
  }
  int getDessert() {
    return dessert;
  }
  void setDessert(int d) {
    dessert=d;
  }

  int getMonth() {
    return _month;
  }
  void setMonth(int m) {
    _month = m;
  }
  int getYear() {
    return _year;
  }
  void setYear(int y) {
    _year=y;
  }
}

class foods {
  String type;
  int count;
  int rank;
  foods(String type, int count) {
    this.type = type;
    this.count = count;
  }
  String getType() {
    return type;
  }
  void setType(String t) {
    type = t;
  }
  int getCount() {
    return count;
  }
  void setCount(int c) {
    count = c;
  }
  int getRank() {
    return rank;
  }
  void setRank(int c) {
    rank = c;
  }
}

void drawText() {
  //title
  textFont(fnt, 22);
  textAlign(CENTER);
  fill(#FFFFFF);
  stroke(#808080);
  text("Ranking Cuisines: New York Times vs. Seattle Public Library", width*.5, height*.055);
  //cuisines
  textFont(fnt, 16);
  textAlign(CENTER);
  smooth();
  
  
  //text("CUISINE", width*.055, _height*.09 + 25 /* .8*_height/6*/);
  fill(#FFFFFF);
  //rect( width*.055/2-18, _height*.09+11, 80, 165);
  
//  if(typeAtXY == "Dessert")
//    fill(dessertColor[3],dessertColor[4],dessertColor[5]);
//  else
//    fill(dessertColor[0],dessertColor[1],dessertColor[2]);
  text("Dessert", width*.055-3, .8*_height/6+20);
  
//  if(typeAtXY == "Spanish")
//    fill(spanishColor[3],spanishColor[4],spanishColor[5]);
//  else
//    fill(spanishColor[0],spanishColor[1],spanishColor[2]);
  text("Spanish", width*.055-3, 2*.8*_height/6+20);
  
//  if(typeAtXY == "Chinese") 
//    fill(chineseColor[3],chineseColor[4],chineseColor[5]);
//  else
//    fill(chineseColor[0],chineseColor[1],chineseColor[2]);
  text("Chinese", width*.055-3, 3*.8*_height/6+20); 
  
//  if(typeAtXY == "French") 
//    fill(frenchColor[3],frenchColor[4],frenchColor[5]);
//  else
//    fill(frenchColor[0],frenchColor[1],frenchColor[2]);
  text("French", width*.055-3, 4*.8*_height/6+20);
  
//  if(typeAtXY == "Vegetarian")
//    fill(vegetarianColor[3],vegetarianColor[4],vegetarianColor[5]);
//  else
//    fill(vegetarianColor[0],vegetarianColor[1],vegetarianColor[2]);
  text("Vegetarian", width*.055-3, 5*.8*_height/6+20);
  
//  if(typeAtXY == "Italian")
//  fill(italianColor[3],italianColor[4],italianColor[5]);
//  else
//    fill(italianColor[0],italianColor[1],italianColor[2]);
  text("Italian", width*.055-3, 6*.8*_height/6+20);

  //years
  textFont(fnt, 18);
  textAlign(CENTER);
  fill(#FFFFFF);
  stroke(#FFFFFF);
  text("2007", _width*.025 + 1*.8*_width/5, height*.955-10);
  text("2008", _width*.025 + 2*.8*_width/5, height*.955-10);
  text("2009", _width*.025 + 3*.8*_width/5, height*.955-10);
  text("2010", _width*.025 + 4*.8*_width/5, height*.955-10);
  text("2011", _width*.025 + 5*.8*_width/5, height*.955-10);
  
  //Rank
  smooth();
  textAlign(CENTER);
  fill(#FFFFFF);
  textFont(fnt, 14);
  //textAlign(RIGHT);
  text("Rank",width-width*.055, .8*_height/6);
  fill(dessertColor[0],dessertColor[1],dessertColor[2]);
  stroke(dessertColor[0],dessertColor[1],dessertColor[2]);
  
  text("1", width-width*.055, .8*_height/6+1*20);
  rect( width-width*.055-20, .8*_height/6+1*20-11,10,10);
  
  fill(spanishColor[0],spanishColor[1],spanishColor[2]);
  stroke(spanishColor[0],spanishColor[1],spanishColor[2]);
  text("2", width-width*.055, .8*_height/6+2*20); 
  rect( width-width*.055-20, .8*_height/6+2*20-11,10,10);
  
  fill(chineseColor[0],chineseColor[1],chineseColor[2]); 
  stroke(chineseColor[0],chineseColor[1],chineseColor[2]); 
  text("3", width-width*.055, .8*_height/6+3*20);
  rect( width-width*.055-20, .8*_height/6+3*20-11,10,10);
  
  fill(frenchColor[0],frenchColor[1],frenchColor[2]); 
  stroke(frenchColor[0],frenchColor[1],frenchColor[2]); 
  text("4", width-width*.055, .8*_height/6+4*20);
  rect( width-width*.055-20, .8*_height/6+4*20-11,10,10);
  
  fill(vegetarianColor[0],vegetarianColor[1],vegetarianColor[2]); 
  stroke(vegetarianColor[0],vegetarianColor[1],vegetarianColor[2]); 
  text("5", width-width*.055, .8*_height/6+5*20);
  rect( width-width*.055-20, .8*_height/6+5*20-11,10,10); 
  
  fill(italianColor[0],italianColor[1],italianColor[2]); 
  stroke(italianColor[0],italianColor[1],italianColor[2]); 
  text("6", width-width*.055, .8*_height/6+6*20);
  rect( width-width*.055-20, .8*_height/6+6*20-11,10,10); 
  /*
  fill(#FFFFFF);
  stroke(#FFFFFF);
  text("NY", width-width*.055+5, .8*_height/6+9*20);
  rect( width-width*.055-20, .8*_height/6+9*20-11,10,10);
  text("Seattle", width-width*.055+20, .8*_height/6+10*20);
  rect( width-width*.055-20, .8*_height/6+10*20-11,10,10);
  */
}

